"use strict";

const filter = {
  urls: ["<all_urls>"]
};

const webNavigation = [
  "onBeforeNavigate",
  "onCommitted",
  "onCompleted",
  "onCreatedNavigationTarget",
  "onDOMContentLoaded",
  // "onErrorOccurred,",
  "onHistoryStateUpdated",
  "onReferenceFragmentUpdated",
  // "onTabReplaced"
];

const webRequest = [
  // "onActionIgnored",
  "onAuthRequired",
  "onBeforeRedirect",
  "onBeforeRequest",
  "onBeforeSendHeaders",
  "onCompleted",
  "onErrorOccurred",
  "onHeadersReceived",
  "onResponseStarted",
  "onSendHeaders"
];

function log(name, {tabId, frameId, parentFrameId, url})
{
  console.log(tabId, frameId, parentFrameId, name, url);
}

for (let name of webNavigation)
{
  chrome.webNavigation[name].addListener(
    log.bind(null, `webNavigation.${name}`),
    filter
  );
}

for (let name of webRequest)
{
  chrome.webRequest[name].addListener(
    log.bind(null, `webRequest.${name}`),
    filter
  );
}
